Merge "Enable trust anchor injection"
[apex-tripleo-heat-templates.git] / extraconfig / tasks / yum_update.sh
1 #!/bin/bash
2
3 # A heat-config-script which runs yum update during a stack-update.
4 # Inputs:
5 #   deploy_action - yum will only be run if this is UPDATE
6 #   update_identifier - yum will only run for previously unused values of update_identifier
7 #   command - yum sub-command to run, defaults to "update"
8 #   command_arguments - yum command arguments, defaults to ""
9
10 echo "Started yum_update.sh on server $deploy_server_id at `date`"
11 echo -n "false" > $heat_outputs_path.update_managed_packages
12
13 if [[ -z "$update_identifier" ]]; then
14     echo "Not running due to unset update_identifier"
15     exit 0
16 fi
17
18 timestamp_dir=/var/lib/overcloud-yum-update
19 mkdir -p $timestamp_dir
20
21 # sanitise to remove unusual characters
22 update_identifier=${update_identifier//[^a-zA-Z0-9-_]/}
23
24 # seconds to wait for this node to rejoin the cluster after update
25 cluster_start_timeout=600
26 galera_sync_timeout=360
27
28 timestamp_file="$timestamp_dir/$update_identifier"
29 if [[ -a "$timestamp_file" ]]; then
30     echo "Not running for already-run timestamp \"$update_identifier\""
31     exit 0
32 fi
33 touch "$timestamp_file"
34
35 command_arguments=${command_arguments:-}
36
37 list_updates=$(yum list updates)
38
39 if [[ "$list_updates" == "" ]]; then
40     echo "No packages require updating"
41     exit 0
42 fi
43
44 pacemaker_status=$(systemctl is-active pacemaker)
45 pacemaker_dumpfile=$(mktemp)
46
47 if [[ "$pacemaker_status" == "active" ]] ; then
48     echo "Dumping Pacemaker config"
49     pcs cluster cib $pacemaker_dumpfile
50
51     echo "Checking for missing constraints"
52
53     if ! pcs constraint order show | grep "start openstack-nova-novncproxy-clone then start openstack-nova-api-clone"; then
54         pcs -f $pacemaker_dumpfile constraint order start openstack-nova-novncproxy-clone then openstack-nova-api-clone
55     fi
56
57     if ! pcs constraint order show | grep "start rabbitmq-clone then start openstack-keystone-clone"; then
58         pcs -f $pacemaker_dumpfile constraint order start rabbitmq-clone then openstack-keystone-clone
59     fi
60
61     if ! pcs constraint order show | grep "promote galera-master then start openstack-keystone-clone"; then
62         pcs -f $pacemaker_dumpfile constraint order promote galera-master then openstack-keystone-clone
63     fi
64
65     if ! pcs constraint order show | grep "start haproxy-clone then start openstack-keystone-clone"; then
66         pcs -f $pacemaker_dumpfile constraint order start haproxy-clone then openstack-keystone-clone
67     fi
68
69     if ! pcs constraint order show | grep "start memcached-clone then start openstack-keystone-clone"; then
70         pcs -f $pacemaker_dumpfile constraint order start memcached-clone then openstack-keystone-clone
71     fi
72
73     if ! pcs constraint order show | grep "promote redis-master then start openstack-ceilometer-central-clone"; then
74         pcs -f $pacemaker_dumpfile constraint order promote redis-master then start openstack-ceilometer-central-clone require-all=false
75     fi
76
77     # ensure neutron constraints https://review.openstack.org/#/c/229466
78     # remove ovs-cleanup after server and add openvswitch-agent instead
79     if  pcs constraint order show  | grep "start neutron-server-clone then start neutron-ovs-cleanup-clone"; then
80         pcs -f $pacemaker_dumpfile constraint remove order-neutron-server-clone-neutron-ovs-cleanup-clone-mandatory
81     fi
82     if ! pcs constraint order show | grep "start neutron-server-clone then start neutron-openvswitch-agent-clone"; then
83         pcs -f $pacemaker_dumpfile constraint order start neutron-server-clone then neutron-openvswitch-agent-clone
84     fi
85
86
87     if ! pcs resource defaults | grep "resource-stickiness: INFINITY"; then
88         pcs -f $pacemaker_dumpfile resource defaults resource-stickiness=INFINITY
89     fi
90
91     echo "Setting resource start/stop timeouts"
92     SERVICES="
93 haproxy
94 memcached
95 httpd
96 neutron-dhcp-agent
97 neutron-l3-agent
98 neutron-metadata-agent
99 neutron-openvswitch-agent
100 neutron-server
101 openstack-ceilometer-alarm-evaluator
102 openstack-ceilometer-alarm-notifier
103 openstack-ceilometer-api
104 openstack-ceilometer-central
105 openstack-ceilometer-collector
106 openstack-ceilometer-notification
107 openstack-cinder-api
108 openstack-cinder-scheduler
109 openstack-cinder-volume
110 openstack-glance-api
111 openstack-glance-registry
112 openstack-heat-api
113 openstack-heat-api-cfn
114 openstack-heat-api-cloudwatch
115 openstack-heat-engine
116 openstack-keystone
117 openstack-nova-api
118 openstack-nova-conductor
119 openstack-nova-consoleauth
120 openstack-nova-novncproxy
121 openstack-nova-scheduler"
122     for service in $SERVICES; do
123         pcs -f $pacemaker_dumpfile resource update $service op start timeout=100s op stop timeout=100s
124     done
125     # mongod start timeout is higher, setting only stop timeout
126     pcs resource update mongod op stop timeout=100s
127
128     echo "Applying new Pacemaker config"
129     pcs cluster cib-push $pacemaker_dumpfile
130
131     echo "Pacemaker running, stopping cluster node and doing full package update"
132     node_count=$(pcs status xml | grep -o "<nodes_configured.*/>" | grep -o 'number="[0-9]*"' | grep -o "[0-9]*")
133     if [[ "$node_count" == "1" ]] ; then
134         echo "Active node count is 1, stopping node with --force"
135         pcs cluster stop --force
136     else
137         pcs cluster stop
138     fi
139 else
140     echo "Excluding upgrading packages that are handled by config management tooling"
141     command_arguments="$command_arguments --skip-broken"
142     for exclude in $(cat /var/lib/tripleo/installed-packages/* | sort -u); do
143         command_arguments="$command_arguments --exclude $exclude"
144     done
145 fi
146
147 command=${command:-update}
148 full_command="yum -y $command $command_arguments"
149 echo "Running: $full_command"
150
151 result=$($full_command)
152 return_code=$?
153 echo "$result"
154 echo "yum return code: $return_code"
155
156 if [[ "$pacemaker_status" == "active" ]] ; then
157     echo "Starting cluster node"
158     pcs cluster start
159
160     hostname=$(hostname -s)
161     tstart=$(date +%s)
162     while [[ "$(pcs status | grep "^Online" | grep -F -o $hostname)" == "" ]]; do
163         sleep 5
164         tnow=$(date +%s)
165         if (( tnow-tstart > cluster_start_timeout )) ; then
166             echo "ERROR $hostname failed to join cluster in $cluster_start_timeout seconds"
167             pcs status
168             exit 1
169         fi
170     done
171
172     tstart=$(date +%s)
173     while ! clustercheck; do
174         sleep 5
175         tnow=$(date +%s)
176         if (( tnow-tstart > galera_sync_timeout )) ; then
177             echo "ERROR galera sync timed out"
178             exit 1
179         fi
180     done
181
182     pcs status
183
184 else
185     echo -n "true" > $heat_outputs_path.update_managed_packages
186 fi
187
188 echo "Finished yum_update.sh on server $deploy_server_id at `date`"
189
190 exit $return_code